<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );
require_once(dirname(__FILE__) . '/jv_zoom/thumbnail.inc.php');
class plgSystemjv_zoom extends JPlugin{
	function __construct(& $subject, $config){
		parent::__construct($subject, $config);
	}
	function onAfterDispatch(){
		global $mainframe;
		$doc	=& JFactory::getDocument();
		$doctype	= $doc->getType();
		JHTML::_('behavior.mootools');
		if ( $doctype !== 'html' ) { return; }
		$cloudZoomJS = JURI::root(true)."/plugins/system/jv_zoom/cloudzoom.js";
		$cloudZoomCss = JURI::root(true)."/plugins/system/jv_zoom/style.css";
		$doc->addScript($cloudZoomJS);
		$doc->addStyleSheet($cloudZoomCss);
		$this->loadManualConfiguration();
		$this->createdDirThumb();
	}
	function loadManualConfiguration(){
		$doc	=& JFactory::getDocument();
		$config = " window.addEvent('load',function(){
			if($$('.jv_zoom').length) {
			$$('.jv_zoom').each(function(item,i){
			new jvZoom({
				'id':i,				
				'zoom_width':'".$this->params->get('zoom_image_width')."',
				'zoom_height':'".$this->params->get('zoom_image_height')."'									
			});			
			});		
			}
		})";
		$doc->addScriptDeclaration($config);
	}
	function onAfterRender(){
		// Return if page is not html
		global $mainframe;
		if ( $mainframe->isAdmin() ) { return; }
		//if (!isset($this->_plugin)) return;
		$_body = JResponse::getBody();
		// Replace {japopup} tag by appropriate content to show popup
		$_body = $this->replaceContent($_body);

		if ( $_body ) {
			JResponse::setBody( $_body );
		}
		return true;
	}
	function replaceContent($_body){
		global $mainframe;
		if ( strpos( $_body, 'jv_zoom' ) === false ) {
			return true;
		}	
		// define the regular expression for the bot
		$regex = "#{jv_zoom(.*?)}(.*?){/jv_zoom}#s";
		// check whether plugin has been unpublished
		// find all instances of plugin and put in $matches
		preg_match_all( $regex, $_body, $matches );
		//var_dump($matches);
		$doc	=& JFactory::getDocument();
		$doctype	= $doc->getType();
		JHTML::_('behavior.mootools');
		if ( $doctype !== 'html' ) { return; }	
		// Number of plugins
		$count = count( $matches[0] );
		if ( $count ) {
			return $this->__processCloudZoomImage( $_body, $matches, $count, $regex );
		}
	}
	function __processCloudZoomImage($_body, $matches, $count, $regex){
		global $mainframe;
		$thumbSize = $this->params->get('zoom_thumb_size',240);
		$aryImages = $matches[2];
		$aryImgAttr = $matches[0];
		if(count($aryImages)){
			$i=0;
			foreach($aryImages as $image){
				$imgAttr = $aryImgAttr[$i];
				$aryAttr = array();
				$aryThumb = $aryTitle = array();
				$title = "";
				$effectType = "effectType:default";
				preg_match( "#effect=\"(.*?)\"#s",$imgAttr, $aryAttr);
				preg_match( "#title=\"(.*?)\"#s",$imgAttr, $aryTitle);
				preg_match( "#width=\"(.*?)\"#s",$imgAttr, $aryThumb);
				if($aryAttr) $effectType = "effectType:".$aryAttr[1];
				if($aryTitle) $title = $aryTitle[1];
				if($aryThumb) $thumbSize = $aryThumb[1];				
				$thumbPath = '';
				if(is_file(trim($image))){
					$thumbPath = $this->__getThumb($thumbSize,trim($image));
					$altText = '<div class="jv_zoom_container">
						<a rel="'.$effectType.'" class="jv_zoom" href="'.$image.'" style="position:relative;display:block">
							<img style="display:block;" alt="" title="'.$title.'" src="'.$thumbPath.'" />
						</a>			
					</div><div class="cls"></div>';					
				}
				$_body = str_replace( $matches[0][$i], $altText, $_body );
				$i++;
			}
		}
		return $_body;		
	}
	function createdDirThumb($comp='jv_zoom'){
		$thumbImgParentFolder = JPATH_BASE.DS.'images'.DS.'stories'.DS.'thumbs'.DS.$comp;
		if(!JFolder::exists($thumbImgParentFolder)){
			JFolder::create($thumbImgParentFolder);
		}
	}
	function __getThumb($thumbSize,$image_path,$reflections=false){
		// create a thumb filename
		$fileName = basename($image_path);
		$imgName = substr($fileName,0,strripos($fileName,'.')).'_thumb'.$thumbSize;
		$file_div = strrpos($image_path,'.');
		$thumb_ext = substr($image_path, $file_div);
		$thumb_prev = substr($image_path, 0, $file_div);
		$thumb_path = 'images/stories/thumbs/jv_zoom/'.$imgName.$thumb_ext;
		if(file_exists($thumb_path)) @unlink($thumb_path);
		// check to see if this file exists, if so we don't need to create it
		if ($thumb_path !='' && function_exists("gd_info") && !file_exists($thumb_path)) {
			// file doens't exist, so create it and save it
			$thumb = new JVThumbnail($image_path);
			if ($thumb->error) {
				if ($showbug)   echo "JV Image ERROR: " . $thumb->errmsg . ": " . $image_path;
				return false;
			}
			$thumb->resize($thumbSize);
			if ($reflections) {
				$thumb->createReflection(30,30,60,false);
			}
			if (!is_writable(dirname($thumb_path))) {
				$thumb->destruct();
				return false;
			}
			$thumb->save($thumb_path);
			$thumb->destruct();
		}
		return ($thumb_path);
	}
}
